# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`oauth2_proxy`](#oauth2_proxy): Class to install and configure an oauth2_proxy
* [`oauth2_proxy::install`](#oauth2_proxyinstall): Class to install and configure an oauth2_proxy
This class should be considered private.
* [`oauth2_proxy::params`](#oauth2_proxyparams): Class with default parameters
This class should be considered private.

### Defined types

* [`oauth2_proxy::instance`](#oauth2_proxyinstance): Defined type to configure a oauth2_proxy instance

## Classes

### <a name="oauth2_proxy"></a>`oauth2_proxy`

Class to install and configure an oauth2_proxy

#### Parameters

The following parameters are available in the `oauth2_proxy` class:

* [`manage_user`](#manage_user)
* [`manage_group`](#manage_group)
* [`manage_service`](#manage_service)
* [`user`](#user)
* [`group`](#group)
* [`install_root`](#install_root)
* [`version`](#version)
* [`source_base_url`](#source_base_url)
* [`tarball_name`](#tarball_name)
* [`provider`](#provider)
* [`shell`](#shell)
* [`systemd_path`](#systemd_path)
* [`instances`](#instances)

##### <a name="manage_user"></a>`manage_user`

Data type: `Boolean`

Should the module manage the user creation
Default: true

Default value: `$oauth2_proxy::params::manage_user`

##### <a name="manage_group"></a>`manage_group`

Data type: `Boolean`

Should the module manage the group creation
Default: true

Default value: `$oauth2_proxy::params::manage_group`

##### <a name="manage_service"></a>`manage_service`

Data type: `Boolean`

Should the module manage the systemd service
Default: true

Default value: `$oauth2_proxy::params::manage_service`

##### <a name="user"></a>`user`

Data type: `String`

The useraccount to create the files needed for the proxy
Default: 'oauth2'

Default value: `$oauth2_proxy::params::user`

##### <a name="group"></a>`group`

Data type: `String`

The users group accountname
Default: same as user

Default value: `$oauth2_proxy::params::group`

##### <a name="install_root"></a>`install_root`

Data type: `Stdlib::Unixpath`

The path where the proxy will be installed
Default: '/opt/oauth2_proxy'

Default value: `$oauth2_proxy::params::install_root`

##### <a name="version"></a>`version`

Data type: `String`

The version of oauth2_proxy to install
Default: '6.1.1'

Default value: `$oauth2_proxy::params::version`

##### <a name="source_base_url"></a>`source_base_url`

Data type: `Stdlib::HTTPUrl`

The base URL where the software tarball can be found
Default: "https://github.com/oauth2-proxy/oauth2-proxy/releases/download/v${version}"

Default value: `$oauth2_proxy::params::source_base_url`

##### <a name="tarball_name"></a>`tarball_name`

Data type: `String`

The name of the tarball
Default: "oauth2-proxy-v${version}.linux-amd64.tar.gz"

Default value: `$oauth2_proxy::params::tarball_name`

##### <a name="provider"></a>`provider`

Data type: `String`

Provider to use
Default: 'systemd'

Default value: `$oauth2_proxy::params::provider`

##### <a name="shell"></a>`shell`

Data type: `Stdlib::Unixpath`

Shell to use for oauth2 user
Default: '/sbin/nologin'

Default value: `$oauth2_proxy::params::shell`

##### <a name="systemd_path"></a>`systemd_path`

Data type: `Stdlib::Unixpath`

Path of systemd
Default: '/usr/lib/systemd/system'

Default value: `$oauth2_proxy::params::systemd_path`

##### <a name="instances"></a>`instances`

Data type: `Optional[Hash]`

A Hash of oauth2_proxy instances and its configuration
Default: '/usr/lib/systemd/system'

Default value: ``undef``

### <a name="oauth2_proxyinstall"></a>`oauth2_proxy::install`

Class to install and configure an oauth2_proxy
This class should be considered private.

### <a name="oauth2_proxyparams"></a>`oauth2_proxy::params`

Class with default parameters
This class should be considered private.

## Defined types

### <a name="oauth2_proxyinstance"></a>`oauth2_proxy::instance`

Defined type to configure a oauth2_proxy instance

#### Parameters

The following parameters are available in the `oauth2_proxy::instance` defined type:

* [`config`](#config)

##### <a name="config"></a>`config`

Data type: `Hash`

Hash with configuration parameter for oauth2_proxy
Details can be founce here https://oauth2-proxy.github.io/oauth2-proxy/docs/6.1.x/configuration/overview

